package com.zhongzheng.modules.user.service;

import com.zhongzheng.modules.exam.domain.ExamNumber;
import com.zhongzheng.modules.user.domain.UserExamGoods;
import com.zhongzheng.modules.user.vo.UserExamGoodsVo;
import com.zhongzheng.modules.user.bo.UserExamGoodsQueryBo;
import com.zhongzheng.modules.user.bo.UserExamGoodsAddBo;
import com.zhongzheng.modules.user.bo.UserExamGoodsEditBo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.Collection;
import java.util.List;

/**
 * 用户下这个商品的考试次数，前培次数Service接口
 *
 * @author ruoyi
 * @date 2021-12-07
 */
public interface IUserExamGoodsService extends IService<UserExamGoods> {
	/**
	 * 查询单个
	 * @return
	 */
	UserExamGoodsVo queryById(Long userExamGoodsId);

	/**
	 * 查询列表
	 */
	List<UserExamGoodsVo> queryList(UserExamGoodsQueryBo bo);

	/**
	 * 根据新增业务对象插入用户下这个商品的考试次数，前培次数
	 * @param bo 用户下这个商品的考试次数，前培次数新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(UserExamGoodsAddBo bo);

	/**
	 * 根据编辑业务对象修改用户下这个商品的考试次数，前培次数
	 * @param bo 用户下这个商品的考试次数，前培次数编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserExamGoodsEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	List<UserExamGoodsVo> listUserExam(UserExamGoodsQueryBo bo);

	UserExamGoodsVo getUserExamInfo(UserExamGoodsQueryBo userExamGoodsQueryBo);

    Long queryExamGoods(Long goodsId,Long userId);

	ExamNumber queryExam(Long goodsId);

}
